library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity ALSmain is
 port (t: in  std_logic;
   start: in  std_logic;
   start_ack: buffer std_logic;
   CS  : buffer std_logic := '1';
   SDI : in   std_logic;
   SCK : out  std_logic;
   LED : out  std_logic_vector(7 downto 0));
end ALSmain;

architecture a of ALSmain is
 signal idx: natural range 0 to 31:=0; -- Initialisierung, damit Wandlerzeit eingehalten wird
 signal start_del: std_logic;
begin

 SCK <= t;

 process(t)
 begin
  if rising_edge(t) then
   start_del <= start;
   if start_del='0' then start_ack <= '0'; end if;

   if CS='1' then
	if idx < 3 then idx <= idx +1;
    elsif (start_del='1') and (start_ack = '0') then 
     CS <='0'; start_ack <='1'; idx <= 0; 
    end if;
   else
    CS <= '0';
    idx <= idx +1;
    if idx>2 and idx < 11 then led(10 - idx) <= SDI;
    elsif idx = 15 then CS <= '1'; idx <= 0;
    end if;
   end if;
  end if;
 end process;
end architecture;

